House Robber 打家劫舍

//

//  main.cpp

//  robber

//

//  Created by dongfucai on 2018/9/28.

//  Copyright © 2018年 dongfucai. All rights reserved.

//

 

#include

#include "vector"

 

using namespace std;

 

/*

 

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Credits:
Special thanks to @ifanchu for adding this problem and creating all test cases. Also thanks to @ts for adding additional test cases.

 这道题的本质相当于在一列数组中取出一个或多个不相邻数,使其和最大。

 

 我们先拿一个简单的例子来分析一下,比如说nums为{3, 2, 1, 5},那么我们来看我们的dp数组应该是什么样的,首先dp[0]=3没啥疑问,再看dp[1]是多少呢,由于3比2大,所以我们抢第一个房子的3,当前房子的2不抢,所以dp[1]=3,那么再来看dp[2],由于不能抢相邻的,所以我们可以用再前面的一个的dp值加上当前的房间值,和当前房间的前面一个dp值比较,取较大值当做当前dp值,所以我们可以得到状态转移方程dp[i] = max(num[i] + dp[i - 2], dp[i - 1]), 由此看出我们需要初始化dp[0]和dp[1],其中dp[0]即为num[0],dp[1]此时应该为max(num[0], num[1]),代码如下:

 */

class Solution{

    

    public :

    int rob(vector &nums){

        if (nums.size() <= 1) {

            return nums.empty() ? 0 : nums[0];

        }

        vector dp = {nums[0], max(nums[0], nums[1])};

        for (int i = 2; i < nums.size(); ++i) {

            dp.push_back(max(dp[i-1], dp[i-2] + nums[i]));

        }

        return dp.back();

    }

    

};

 

int main(int argc, const char * argv[]) {

    // insert code here...

 

    int temp[] = {4, 5, 6, 6, 2, 5};

    shared_ptr solution(new Solution);

    //Solution s = new Solution;

    vector ivec(temp, temp + 6);

    cout << solution->rob(ivec) << endl;

    

 

    std::cout << "Hello, World!\n";

    return 0;

}

你可能感兴趣的:(leetcode)